## hdmi2usb-mode-switch 0.0.0+git20161016

=== Makefile ===

# conda
export PATH := $(shell pwd)/conda/bin:$(PATH)

conda:
	wget -c https://repo.continuum.io/miniconda/Miniconda3-latest-Linux-x86_64.sh
	chmod a+x Miniconda3-latest-Linux-x86_64.sh
	./Miniconda3-latest-Linux-x86_64.sh -p $@ -b
	conda config --set always_yes yes --set changeps1 no
	conda update -q conda
	conda config --add channels timvideos
	conda install openocd
	pip install pyusb
	pip install pep8
	pip install autopep8
	python setup.py develop

check-conda:
	[ -d conda ]

clean-conda:
	rm -rf Miniconda3-latest-Linux-x86_64.sh
	rm -rf conda

# pypi upload
test-upload:
	python setup.py register -r pypitest
	python setup.py sdist upload -r pypitest

upload:
	python setup.py register -r pypi
	python setup.py sdist upload -r pypi

# Unbind helper - needs to be setuid
bin/unbind-helper:
	@echo "Making setuid unbind helper program."
	gcc -Wall -std=c99 unbind-helper.c -o $@
	sudo chmod 755 $@
	sudo chown root:root $@
	sudo chmod u+s $@
	ls -l $@

unbind-helper:
	@make check-unbind-helper || make bin/unbind-helper

check-unbind-helper:
	@[ -e bin/unbind-helper ]
	@[ "$$(stat -c "%a %U" bin/unbind-helper)" = "4755 root" ]

clean-unbind-helper:
	if [ -e bin/unbind-helper ]; then sudo rm bin/unbind-helper; fi

# udev rules
install-udev:
	cd udev; make install

check-udev:
	cd udev; make check

uninstall-udev:
	cd udev; make uninstall

# Useful python targets
version:
	python setup.py version

check:
	pep8 hdmi2usb --ignore=E402
	pep8 *.py

fix:
	autopep8 -v -r -i -a -a hdmi2usb

test:
	python -m "hdmi2usb.modeswitch.tests"
	python hdmi2usb/modeswitch/files.py hdmi2usb/firmware/spartan6/atlys/bscan_spi_xc6slx45.bit
	python setup.py test

root-test:
	sudo make test

# ???
read-dna:
	./hdmi2usb-mode-switch.py --verbose --mode=jtag
	which openocd
	openocd --file board/numato_opsis.cfg -c "init; xc6s_print_dna xc6s.tap; exit"

update-usb-ids:
	rm USB-IDs.md
	wget https://raw.githubusercontent.com/wiki/timvideos/HDMI2USB/USB-IDs.md -O USB-IDs.md
	git add USB-IDs.md
	git commit -m "Updating the USB-IDs.md file"

# Global rules
clean:
	make clean-conda
	make clean-unbind-helper
	git clean -d -x -f

setup:
	if ! make check-conda; then \
		make -s conda; \
	fi
	if ! make check-unbind-helper; then \
		make -s unbind-helper; \
	fi
	if ! make check-udev; then \
		make -s install-udev; \
	fi

all:
	@echo "Checking setup...."
	@make --quiet setup
	@echo
	@echo "Running code checks...."
	@make --quiet check
	@echo
	@echo "Running tests...."
	@make --quiet test
	@echo
	@echo "Printing version info...."
	@make --quiet version
	@echo

.PHONY: bin/unbind-helper
.DEFAULT_GOAL := all

=== debian/changelog ===
hdmi2usb-mode-switch (0.0.0+git20161016-1) unstable; urgency=low

  * Initial packaging (Closes: #845107)

 -- Stefano Rivera <stefanor@debian.org>  Sun, 20 Nov 2016 15:15:53 +0100

=== debian/control ===
Source: hdmi2usb-mode-switch
Section: admin
Priority: optional
Maintainer: Stefano Rivera <stefanor@debian.org>
Build-Depends:
 debhelper (>= 9),
 dh-exec,
 dh-python,
 python3,
 python3-setuptools
Standards-Version: 3.9.8
Homepage: https://hdmi2usb.tv/
Vcs-Git: https://anonscm.debian.org/git/collab-maint/hdmi2usb-mode-switch.git
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/hdmi2usb-mode-switch.git

Package: hdmi2usb-mode-switch
Architecture: all
Recommends: openocd (>= 0.9.0+git20150701)
Depends: fxload, hdmi2usb-udev, ${misc:Depends}, ${python3:Depends}
Description: Configuration and firmware tool for HDMI2USB devices
 This is the tool for flashing and configuring the HDMI2USB devices.
 .
 It can load a runtime firmware, and write firmware to the device's flash.
 .
 https://hdmi2usb.tv/ is an open hardware and software project for capturing
 HDMI video with an FPGA board. This package supports the Digilent Atlys and
 Numato Opsis boards.

Package: hdmi2usb-udev
Architecture: all
Depends: ${misc:Depends}
Description: udev rules for HDMI2USB devices
 This package provides a set of udev rules files for HDMI2USB devices. They
 grant access to users in the "video" group, provide stable device symlinks,
 and suppress ModemManager.
 .
 https://hdmi2usb.tv/ is an open hardware and software project for capturing
 HDMI video with an FPGA board. This package supports the Digilent Atlys and
 Numato Opsis boards.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export PYBUILD_DESTDIR=debian/hdmi2usb-mode-switch
export PYBUILD_INSTALL_ARGS=--install-lib=/usr/share/hdmi2usb-mode-switch/ \
                            --install-scripts=/usr/share/hdmi2usb-mode-switch/

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_auto_install:
	dh_auto_install
	# udev rules
	sed -e's#/etc/udev/rules.d/hdmi2usb-human-path-helper.sh#/lib/udev/hdmi2usb-human-path-helper#' \
		udev/*.rules > debian/hdmi2usb-udev.udev

override_dh_auto_test:
	# Only one test, and it isn't really appliccable to an autobuilder environment

## hdmi2usb-mode-switch 0.0.0+git20161124

=== Makefile ===
--- 
+++ 
@@ -13,7 +13,7 @@
 	pip install pyusb
 	pip install pep8
 	pip install autopep8
-	python setup.py develop
+	python3 setup.py develop
 
 check-conda:
 	[ -d conda ]
@@ -24,12 +24,12 @@
 
 # pypi upload
 test-upload:
-	python setup.py register -r pypitest
-	python setup.py sdist upload -r pypitest
+	python3 setup.py register -r pypitest
+	python3 setup.py sdist upload -r pypitest
 
 upload:
-	python setup.py register -r pypi
-	python setup.py sdist upload -r pypi
+	python3 setup.py register -r pypi
+	python3 setup.py sdist upload -r pypi
 
 # Unbind helper - needs to be setuid
 bin/unbind-helper:
@@ -62,7 +62,7 @@
 
 # Useful python targets
 version:
-	python setup.py version
+	python3 setup.py version
 
 check:
 	pep8 hdmi2usb --ignore=E402
@@ -72,9 +72,10 @@
 	autopep8 -v -r -i -a -a hdmi2usb
 
 test:
-	python -m "hdmi2usb.modeswitch.tests"
-	python hdmi2usb/modeswitch/files.py hdmi2usb/firmware/spartan6/atlys/bscan_spi_xc6slx45.bit
-	python setup.py test
+	python3 -m "hdmi2usb.modeswitch.tests"
+	python3 hdmi2usb/modeswitch/files.py hdmi2usb/firmware/spartan6/atlys/bscan_spi_xc6slx45.bit
+	python3 setup.py test
+	$(MAKE) -C udev test
 
 root-test:
 	sudo make test

=== udev/Makefile ===

# udev rules
install:
	@for RULE in *-hdmi2usb*.rules; do \
		echo "Installing $$RULE to /etc/udev/rules.d/$$RULE"; \
		sudo cp $$RULE /etc/udev/rules.d/$$RULE; \
		sudo chmod 644 /etc/udev/rules.d/$$RULE; \
		sudo chown root:root /etc/udev/rules.d/$$RULE; \
	done
	@for HELP in hdmi2usb-*-helper.sh; do \
		echo "Installing $$HELP to /etc/udev/rules.d/$$HELP"; \
		sudo cp $$HELP /etc/udev/rules.d/$$HELP; \
		sudo chmod 755 /etc/udev/rules.d/$$HELP; \
		sudo chown root:root /etc/udev/rules.d/$$HELP; \
	done
	echo "udev rules installed; 'make reload' to reload udev rules"

reload:
	sudo udevadm control --reload-rules

install-reload:
	make install
	make reload

check:
	@for RULE in *-hdmi2usb*.rules; do \
		echo -n "Checking installed $$RULE.."; \
		[ -e /etc/udev/rules.d/$$RULE ] || exit 1; \
		diff -u $$RULE /etc/udev/rules.d/$$RULE || exit 1; \
		echo " Good!"; \
	done
	@for HELP in hdmi2usb-*-helper.sh; do \
		echo -n "Checking installed $$HELP.."; \
		[ -e /etc/udev/rules.d/$$HELP ] || exit 1; \
		diff -u $$HELP /etc/udev/rules.d/$$HELP || exit 1; \
		echo " Good!"; \
	done
	@if ! id | grep -qF '(video)'; then \
		echo "Not a member of the video group"; exit 1; \
	fi

test:
	@for HELP in hdmi2usb-*-helper.sh; do \
		echo "Checking $$HELP.."; \
		SHELL=/bin/posh posh $$HELP test || exit 1; \
		echo " Good!"; \
	done

uninstall:
	sudo rm -f /etc/udev/rules.d/*hdmi2usb*

examine:
	make uninstall
	make install
	@echo -e "\n\n\n============================================="
	@udevadm test '/sys/class/tty/ttyACM0'
	@echo -e "\n\n\n============================================="
	@udevadm test '/sys/class/video4linux/video0'

.DEFAULT_GOAL := check

=== debian/changelog ===
hdmi2usb-mode-switch (0.0.0+git20161124-2) unstable; urgency=medium

  * Ship metainfo file describing USB hardware IDs.

 -- Stefano Rivera <stefanor@debian.org>  Mon, 26 Dec 2016 20:48:05 +0100

hdmi2usb-mode-switch (0.0.0+git20161124-1) unstable; urgency=medium

  * New upstream snapshot.
  * Drop patches device-permissions and fxload-locations, superseded upstream.
  * Reproducibly order udev rules contents (Closes: #845763)
  * Document firmware copyright and source locations.
  * Patch flashproxy-source: Include flash proxy source, as that isn't
    currently in Debian.
  * Add symlinks to /usr/bin (which were missing in 0.0.0+git20161016-1,
    because of an overreaching upstream .gitignore).

 -- Stefano Rivera <stefanor@debian.org>  Mon, 26 Dec 2016 19:47:24 +0100

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,13 @@
 Package: hdmi2usb-mode-switch
 Architecture: all
 Recommends: openocd (>= 0.9.0+git20150701)
-Depends: fxload, hdmi2usb-udev, ${misc:Depends}, ${python3:Depends}
+Depends:
+ fxload,
+ hdmi2usb-fx2-firmware,
+ hdmi2usb-udev,
+ ixo-usb-jtag,
+ ${misc:Depends},
+ ${python3:Depends}
 Description: Configuration and firmware tool for HDMI2USB devices
  This is the tool for flashing and configuring the HDMI2USB devices.
  .

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%HDMI2USB-mode-switch-$1.tar.gz%" \
 https://github.com/timvideos/HDMI2USB-mode-switch/releases \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## hdmi2usb-mode-switch 0.0.0+git20170520

=== Makefile ===
--- 
+++ 
@@ -13,6 +13,7 @@
 	pip install pyusb
 	pip install pep8
 	pip install autopep8
+	pip install setuptools-pep8
 	python3 setup.py develop
 
 check-conda:
@@ -52,7 +53,7 @@
 
 # udev rules
 install-udev:
-	cd udev; make install
+	cd udev; make install; make reload
 
 check-udev:
 	cd udev; make check

=== udev/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 
 # udev rules
 install:
-	@for RULE in *-hdmi2usb*.rules; do \
+	@for RULE in *.rules; do \
 		echo "Installing $$RULE to /etc/udev/rules.d/$$RULE"; \
 		sudo cp $$RULE /etc/udev/rules.d/$$RULE; \
 		sudo chmod 644 /etc/udev/rules.d/$$RULE; \
@@ -23,7 +23,7 @@
 	make reload
 
 check:
-	@for RULE in *-hdmi2usb*.rules; do \
+	@for RULE in *.rules; do \
 		echo -n "Checking installed $$RULE.."; \
 		[ -e /etc/udev/rules.d/$$RULE ] || exit 1; \
 		diff -u $$RULE /etc/udev/rules.d/$$RULE || exit 1; \
@@ -50,8 +50,6 @@
 	sudo rm -f /etc/udev/rules.d/*hdmi2usb*
 
 examine:
-	make uninstall
-	make install
 	@echo -e "\n\n\n============================================="
 	@udevadm test '/sys/class/tty/ttyACM0'
 	@echo -e "\n\n\n============================================="

=== debian/changelog ===
hdmi2usb-mode-switch (0.0.0+git20170520-1) unstable; urgency=medium

  * New upstream snapshot.
    - Supports flashing LM32 firmware.
  * Drop patch setuptools-pep8, superseded upstream.
  * Add missing dependencies on usbutils, and python3-pkg-resources.

 -- Stefano Rivera <stefanor@debian.org>  Wed, 02 Aug 2017 12:44:35 -0400

=== debian/control ===
--- 
+++ 
@@ -21,6 +21,8 @@
  hdmi2usb-fx2-firmware,
  hdmi2usb-udev,
  ixo-usb-jtag,
+ python3-pkg-resources,
+ usbutils,
  ${misc:Depends},
  ${python3:Depends}
 Description: Configuration and firmware tool for HDMI2USB devices

=== debian/watch ===
version=3

opts=uversionmangle=s/(rc|a|b|c)/~$1/ \
https://pypi.debian.net/hdmi2usb.modeswitch/hdmi2usb.modeswitch-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## hdmi2usb-mode-switch 0.0.1

=== udev/Makefile ===
--- 
+++ 
@@ -16,7 +16,8 @@
 	echo "udev rules installed; 'make reload' to reload udev rules"
 
 reload:
-	sudo udevadm control --reload-rules
+	sudo udevadm control --reload-rules; \
+	sudo udevadm trigger
 
 install-reload:
 	make install

=== debian/changelog ===
hdmi2usb-mode-switch (0.0.1-4) unstable; urgency=medium

  [ Chris Hofstaedtler ]
  * Use pkg-config to determine install path for udev files.
    (Closes: #1057769)

  [ Stefano Rivera ]
  * Bump Standards-Version to 4.6.2, no changes needed.

 -- Stefano Rivera <stefanor@debian.org>  Fri, 08 Dec 2023 10:32:55 -0400

hdmi2usb-mode-switch (0.0.1-3) unstable; urgency=low

  [ Debian Janitor ]
  * Bump debhelper from deprecated 9 to 12.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Use canonical URL in Vcs-Git.
  * Apply multi-arch hints.
    + hdmi2usb-udev: Add Multi-Arch: foreign.
  * Remove constraints unnecessary since buster:
    + hdmi2usb-mode-switch: Drop versioned constraint on ixo-usb-jtag and
      openocd in Depends.

  [ Stefano Rivera ]
  * Bump debhelper from old 12 to 13.
  * Update watch file format version to 4.
  * Declare: Rules-Requires-Root: no.
  * Bump Standards-Version to 4.6.1, no changes needed.
  * Bump copyright years.
  * Patch: Udev: Add a suffix to /dev/video device nodes to disambiguate them.
    (Closes: #1011938)
  * Move udev rules to priority 70, to come after 60-persistent-v4l.rules.

 -- Stefano Rivera <stefanor@debian.org>  Fri, 27 May 2022 12:13:39 +0200

hdmi2usb-mode-switch (0.0.1-2) unstable; urgency=medium

  * Update symlinks for ixo-usb-jtag 0.0.1.
  * Promote openocd from a Recommends to a Depends. It is needed for most of
    the things one would actually do with mode-switch.

 -- Stefano Rivera <stefanor@debian.org>  Fri, 19 Jan 2018 18:28:58 +1100

hdmi2usb-mode-switch (0.0.1-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Add PGP keyring for source verification.
  * Migrate to salsa.debian.org.
  * Bump Standards-Version to 4.1.3, no changes needed.

 -- Stefano Rivera <stefanor@debian.org>  Sun, 14 Jan 2018 19:03:32 +1100

=== debian/control ===
--- 
+++ 
@@ -3,24 +3,27 @@
 Priority: optional
 Maintainer: Stefano Rivera <stefanor@debian.org>
 Build-Depends:
- debhelper (>= 9),
+ debhelper-compat (= 13),
  dh-exec,
  dh-python,
+ pkgconf,
  python3,
- python3-setuptools
-Standards-Version: 3.9.8
+ python3-setuptools,
+ systemd-dev,
+Standards-Version: 4.6.2
 Homepage: https://hdmi2usb.tv/
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/hdmi2usb-mode-switch.git
-Vcs-Browser: https://anonscm.debian.org/git/collab-maint/hdmi2usb-mode-switch.git
+Vcs-Git: https://salsa.debian.org/debian/hdmi2usb-mode-switch.git
+Vcs-Browser: https://salsa.debian.org/debian/hdmi2usb-mode-switch
+Rules-Requires-Root: no
 
 Package: hdmi2usb-mode-switch
 Architecture: all
-Recommends: openocd (>= 0.9.0+git20150701)
 Depends:
  fxload,
  hdmi2usb-fx2-firmware,
  hdmi2usb-udev,
  ixo-usb-jtag,
+ openocd,
  python3-pkg-resources,
  usbutils,
  ${misc:Depends},
@@ -37,6 +40,7 @@
 Package: hdmi2usb-udev
 Architecture: all
 Depends: ${misc:Depends}
+Multi-Arch: foreign
 Description: udev rules for HDMI2USB devices
  This package provides a set of udev rules files for HDMI2USB devices. They
  grant access to users in the "video" group, provide stable device symlinks,

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_DESTDIR=debian/hdmi2usb-mode-switch
export PYBUILD_INSTALL_ARGS=--install-lib=/usr/share/hdmi2usb-mode-switch/ \
                            --install-scripts=/usr/share/hdmi2usb-mode-switch/

export deb_udevdir = $(shell pkg-config --variable=udevdir udev | sed s,^/,,)

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_auto_install:
	dh_auto_install
	# udev rules
	sed -e's#/etc/udev/rules.d/hdmi2usb-human-path-helper.sh#/'$(deb_udevdir)'/hdmi2usb-human-path-helper#' \
		$(sort $(wildcard udev/*.rules)) > debian/hdmi2usb-udev.udev

override_dh_auto_test:
	# Only one test, and it isn't really appliccable to an autobuilder environment

override_dh_installudev:
	# Sort after 60-persistent-v4l.rules
	dh_installudev --priority=70
